/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _DEFS_H
#define _DEFS_H

/*  this file #defines constants which may      *
 *  change during XorGramana development.  not  *
 *  all #defines should be placed here. icons.h *
 *  for example contains #defines which may     *
 *  only relate to icon.c, or may not,          *
 *  distinction too subtle for words...         *
 *  generally, if a #define might be easier to  *
 *  locate by placing it in this file, or more  *
 *  importantly, is required in several include *
 *  files, then place it here by all means.     */


/* DEBUGGING */
#ifdef MAP_DEBUG
#define PLAYER_XY_DEBUG
#endif

#ifdef DEBUG
#define MAP_DEBUG
#define GFX_DEBUG
#define ICON_DEBUG
#define MOVE_DEBUG
#define MISC_DEBUG
#define PLAYER_XY_DEBUG
#endif






/*  icon dimensions                             */
#define ICON_WIDTH 64
#define ICON_HEIGHT 64
#define ICON_EXT ".png"

/*  map related stuf                            */
#define MAPNAME_MAXCHARS 24
#define MIN_LEVEL 1
/* bit ambitious I know: */
#define MAX_LEVEL 25
/* maps may be any size up to: */
#define MAP_MAX_W 64
#define MAP_MAX_H 64

#define MAX_WORDS_TO_SOLVE 20


/*  max number of moves to complete a level     *
 *  note: may become map/level specific         */
#define MAX_MOVES 2000

/* misc */
#define MAX_PRINTLEN 256
#define MAX_BUF_LEN 256
#define TICK_COUNT 16

/* Xor icons - translate from xor map char to xorgramana map    *
 * char. the values of these should be checked against the      *
 * values of the mapchars in icons.c and cross-checked with the *
 * behaviours defined in actions.c - so just trust me.          */
#define XOR_PLAYER2 '0'
#define XOR_FISH 'v'
#define XOR_CHICKEN 'k'
#define XOR_HBOMB 'h'
#define XOR_DOLL 'g'
#define XOR_SWITCH 'y'

#endif
