/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _EXPLODE_H
#define _EXPLODE_H

#include "movelist.h"
#include "types.h"

/*
    explode_process_detonator explodes a bomb. it calculates the
    direction of the blast (pah!) and removes objects from the
    map (if appropriate - ie don't blast holes in map boundary).
*/

/* MAX_EXP_CHECKS defines the maximum number of checks there may    *
 * be after a bomb has exploded - the checks are for gravitating    *
 * objects which due to the explosion, should start gravitating     *
 * ie potentially there is no longer anything to stop them.         *
 * this value is just used for the arrays - the most checks there   *
 * are is nine.                                                     */
#define MAX_EXP_CHECKS 10

void explode_process_detonator(struct xmv_link* detlnk);
void explode_process_h_blast(xy_t bombx, xy_t bomby, su_t detdir);
void explode_process_v_blast(xy_t bombx, xy_t bomby, su_t detdir);

#endif

