/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _GAME_DISPLAY_H
#define _GAME_DISPLAY_H

#include <SDL.h>

#include "map.h"
#include "icons.h"
#include "actions.h"
#include "types.h"
#include "gfx.h"

extern struct gfx_win* game_win;
void game_win_create();
void game_win_destroy();

void game_win_display();
void game_win_update_player_info();
void game_win_show(xy_t cx, xy_t cy);
void game_win_swap_update();
void game_win_move_player(struct xor_move* xmv);
void game_win_move_object(struct xor_move* xmv);

void game_win_get_view_for(xy_t cx, xy_t cy, xy_t* tlx, xy_t* tly);

/*  game_win_map_coord returns pointer to a new xy struct
    of *screen* coordinates of map coordinate x,y. returns
    0 if map coord is off-screen.
*/
struct xy* game_win_map_coord(xy_t x, xy_t y);

/* -------------------------
    game_win_icon_display x,y parameters are map coordinates.
    these are translated to display the icon only if it should
    be displayed in the window
*/
void game_win_icon_display(xy_t x, xy_t y, su_t icon);

#endif
