/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "icons.h"
#include "gfx.h"

struct xg_icon icon_details[ICON_XXX]=
{
    { "floor",      ' ' },
    { "wall",       '#' },
    { "h-field",    '-' },
    { "v-field",    '|' },
    { "hash",       '0' },
    { "star",       '1' },
    { "map",        'M' },
    { "teleport",   '+' },
    { "exit",       'E' },
    { "mask",       '@' },
    { "dot",        '.' },
    { "blank",      '_' },
    { "a", 'a' },
    { "b", 'b' },
    { "c", 'c' },
    { "d", 'd' },
    { "e", 'e' },
    { "f", 'f' },
    { "g", 'g' },
    { "h", 'h' },
    { "i", 'i' },
    { "j", 'j' },
    { "k", 'k' },
    { "l", 'l' },
    { "m", 'm' },
    { "n", 'n' },
    { "o", 'o' },
    { "p", 'p' },
    { "q", 'q' },
    { "r", 'r' },
    { "s", 's' },
    { "t", 't' },
    { "u", 'u' },
    { "v", 'v' },
    { "w", 'w' },
    { "x", 'x' },
    { "y", 'y' },
    { "z", 'z' },
    { "0", '0' },
    { "1", '1' },
    { "2", '2' },
    { "3", '3' },
    { "4", '4' },
    { "5", '5' },
    { "6", '6' },
    { "7", '7' },
    { "8", '8' },
    { "9", '9' },
/***** THE FOLLOWING ARE NOT SPECIFIABLE IN MAP FILE *****/
/***** (hence '\0' as map character specifier)       *****/
    { "exit_open",  '\0'},
    { "space",      '\0'}, /* opaque */
    { "space",      '\0'}, /* transparent */
    { "explode01",  '\0'},
    { "explode02",  '\0'},
    { "explode03",  '\0'},
    { "explode04",  '\0'},
    { "explode05",  '\0'},
    { "line-l",     '\0'},
    { "line-r",     '\0'},
    { "line-t",     '\0'},
    { "line-b",     '\0'},
    { "line-tl",    '\0'},
    { "line-tr",    '\0'},
    { "line-bl",    '\0'},
    { "line-br",    '\0'}
};

char* wall_names[WALL_XXX]=
{
    "wall1",
    "wall2",
    "wall3",
    "wall4",
    "wall5",
    "wall6",
    "wall7",
    "wall4",
    "wall1",
    "wall3",
    "wall2",
    "wall5",
    "wall3",
    "wall2",
    "wall7",
    "wall6",
};

char* floor_names[WALL_XXX]=
{
    "floor1",
    "floor2",
    "floor3",
    "floor4",
    "floor5",
    "floor6",
    "floor7",
    "floor1",
    "floor2",
    "floor7",
    "floor3",
    "floor5",
    "floor6",
    "floor4",
    "floor2",
    "floor1",
};

char* edge_names[WALL_XXX][EDGE_XXX]=
{
    {   "edge1_t",  "edge1_b",  "edge1_l",  "edge1_r"   },
    {   "edge2_t",  "edge2_b",  "edge2_l",  "edge2_r"   },
    {   "edge3_t",  "edge3_b",  "edge3_l",  "edge3_r"   },
    {   "edge4_t",  "edge4_b",  "edge4_l",  "edge4_r"   },
    {   "edge5_t",  "edge5_b",  "edge5_l",  "edge5_r"   },
    {   "edge6_t",  "edge6_b",  "edge6_l",  "edge6_r"   },
    {   "edge7_t",  "edge7_b",  "edge7_l",  "edge7_r"   },
    {   "edge5_t",  "edge5_b",  "edge5_l",  "edge5_r"   },
    {   "edge4_t",  "edge4_b",  "edge4_l",  "edge4_r"   },
    {   "edge2_t",  "edge2_b",  "edge2_l",  "edge2_r"   },
    {   "edge3_t",  "edge3_b",  "edge3_l",  "edge3_r"   },
    {   "edge1_t",  "edge1_b",  "edge1_l",  "edge1_r"   },
    {   "edge7_t",  "edge7_b",  "edge7_l",  "edge7_r"   },
    {   "edge6_t",  "edge6_b",  "edge6_l",  "edge6_r"   },
    {   "edge7_t",  "edge7_b",  "edge7_l",  "edge7_r"   },
    {   "edge4_t",  "edge4_b",  "edge4_l",  "edge4_r"   },
};

char* indicator_names[DIRIND_XXX]=
{
    "grav_u","grav_d","grav_l","grav_r",
    "push_u","push_d","push_l","push_r",
    "hard_push_u","hard_push_d","hard_push_l","hard_push_r",
    "explode_h","explode_v"
};

SDL_Surface* walls[WALL_XXX]={0};
SDL_Surface* floors[WALL_XXX]={0};
SDL_Surface* hs_walls[WALL_XXX]={0};
SDL_Surface* hs_floors[WALL_XXX]={0};
SDL_Surface* wall_edges[WALL_XXX][EDGE_XXX]={{0}};
SDL_Surface* indicators[DIRIND_XXX]={0};
SDL_Surface* edged_walls[ICON_EDGE_TBLR-ICON_EDGE_T]={0};

SDL_Surface* icons[ICON_XXX]={0};
SDL_Surface* hs_icons[ICON_XXX]={0};
SDL_Surface* icons_with_indicators[ICON_XXX]={0};

ss_t current_wall_texture=-1;
enum ICON spc_icon=ICON_FLOOR;

/* private functions */
SDL_Surface* icon_half_assed_size(SDL_Surface* s, bool transparent, int tr_r, int tr_g, int tr_b);
void generate_wall_edging(su_t wall);

void init_icons(void)
{
    char buf[256];
    int i;
    #ifdef ICON_DEBUG
    printf("Loading icons...\n");
    #endif
    for(i=ICON_WALL+1;i<ICON_LOADED_XXX;i++){
        strcpy(buf,"GFX/");
        strcat(buf,icon_details[i].fname);
        strcat(buf,ICON_EXT);
        switch(i){
            /* opaque icons */
            case ICON_FLOOR:
            case ICON_EXIT_OPEN:
            case ICON_LINE_L:
            case ICON_LINE_R:
            case ICON_LINE_T:
            case ICON_LINE_B:
            case ICON_LINE_TL:
            case ICON_LINE_TR:
            case ICON_LINE_BL:
            case ICON_LINE_BR:
            case ICON_SPACE_OPAQUE:
                icons[i]=load_image(buf,FALSE,0,0,0);
                hs_icons[i]=icon_half_assed_size(icons[i],FALSE,0,0,0);
                break;
            default:
                /* icons with black as transparency */
                icons[i]=load_image(buf,TRUE,0,0,0);
                hs_icons[i]=icon_half_assed_size(icons[i],TRUE,0,0,0);
                break;
        }
    }
    for(i=0;i<WALL_XXX;i++){
        /* walls */
        strcpy(buf,"GFX/");
        strcat(buf,wall_names[i]);
        strcat(buf,ICON_EXT);
        walls[i]=load_image(buf,FALSE,0,0,0);
        hs_walls[i]=icon_half_assed_size(walls[i],FALSE,0,0,0);
        /* floors */
        strcpy(buf,"GFX/");
        strcat(buf,floor_names[i]);
        strcat(buf,ICON_EXT);
        floors[i]=load_image(buf,FALSE,0,0,0);
        hs_floors[i]=icon_half_assed_size(floors[i],FALSE,0,0,0);
    }
    for(i=0;i<DIRIND_XXX;i++){
        strcpy(buf,"GFX/");
        strcat(buf,indicator_names[i]);
        strcat(buf,ICON_EXT);
        indicators[i]=load_image(buf,TRUE,0,0,0);
    }
    int j;
    for(i=0;i<WALL_XXX;i++){
        for(j=0;j<EDGE_XXX;j++){
            strcpy(buf,"GFX/");
            strcat(buf,edge_names[i][j]);
            strcat(buf,ICON_EXT);
            wall_edges[i][j]=load_image(buf,TRUE,0xff,0xff,0xff);
        }
    }
}

void init_wall(lvl_t level, bool show)
{
    int w=(level>0?((level-1)%WALL_XXX):0);
    int n;
    icons[ICON_FLOOR]=floors[w];
    hs_icons[ICON_FLOOR]=hs_floors[w];
    if(!show){
        icons[ICON_WALL]=icons[ICON_FLOOR];
        hs_icons[ICON_WALL]=hs_icons[ICON_FLOOR];
        for(n=ICON_EDGE_T;n<=ICON_EDGE_TBLR;n++)
            icons[n]=icons[ICON_FLOOR];
            /* won't bother with half-sized edged walls */
        return;
    }
    icons[ICON_WALL]=walls[w];
    hs_icons[ICON_WALL]=hs_walls[w];
    if(current_wall_texture!=level){
        current_wall_texture=level;
        generate_wall_edging(w);
    }
    for(n=ICON_EDGE_T;n<=ICON_EDGE_TBLR;n++){
        if(!(icons[n]=edged_walls[n-ICON_EDGE_T]))
            icons[n]=icons[ICON_WALL];
    }
        /* won't bother with half-sized edged walls */
}

void icons_cleanup()
{
    int i,w;
    for(i=0;i<ICON_LOADED_XXX;i++){
        if(i!=ICON_WALL&&i!=ICON_FLOOR){
            if(icons[i]){
                SDL_FreeSurface(icons[i]);
                SDL_FreeSurface(hs_icons[i]);
            }
        }
    }
    for(i=0;i<WALL_XXX;i++){
        if(walls[i]){
            SDL_FreeSurface(walls[i]);
            SDL_FreeSurface(hs_walls[i]);
        }
        if(floors[i]){
            SDL_FreeSurface(floors[i]);
            SDL_FreeSurface(hs_floors[i]);
        }
    }
    for(i=0;i<DIRIND_XXX;i++){
        if(indicators[i])
            SDL_FreeSurface(indicators[i]);
    }
    for(w=0;w<WALL_XXX;w++){
        for(i=0;i<EDGE_XXX;i++)
            if(wall_edges[w][i])
                SDL_FreeSurface(wall_edges[w][i]);
    }
    for(i=ICON_EDGE_T;i<=ICON_EDGE_TBLR;i++)
        if(edged_walls[i-ICON_EDGE_T])
            SDL_FreeSurface(edged_walls[i-ICON_EDGE_T]);
}

su_t mapchar_to_icon(char c)
{
    int n;
    if(c<32)
        return ICON_FLOOR;
    for(n=0;n<=ICON_9;n++)
        if(icon_details[n].mapchar==c)
            return n;
    return ICON_FLOOR;
}

su_t char_to_icon(char c)
{
    if(c>='A'&&c<='Z')
        return ICON_A+c-'A';
    if(c>='a'&&c<='z')
        return ICON_A+c-'a';
    if(c>='0'&&c<='9')
        return ICON_1+c-'1';
    switch(c){
        case '#': return ICON_PLAYER0;
        case '*': return ICON_PLAYER1;
        case '+': return ICON_TELEPORT;
        case '-': return ICON_H_FIELD;
        case '|': return ICON_V_FIELD;
        case '.': return ICON_DOT;
        case ' ': return spc_icon;
        case '_': return ICON_FLOOR;
        default:  return spc_icon;
    }
}

void set_space_icon(enum SPACE_CHAR spc)
{
    switch(spc){
        case SPC_TRAN:      spc_icon=ICON_SPACE_TRAN;    break;
        case SPC_OPAQUE:    spc_icon=ICON_SPACE_OPAQUE;  break;
        default:            spc_icon=ICON_FLOOR;         break;
    }
}

SDL_Surface *load_image(char *name, bool transparent, int tr_r, int tr_g, int tr_b)
{
    SDL_Surface *temp=IMG_Load(name);
    SDL_Surface *image;
    if(!temp){
        fprintf(stderr,"Failed to load image %s\n",name);
        return NULL;
    }
    if(transparent)
        SDL_SetColorKey(temp, 
            (SDL_SRCCOLORKEY|SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            tr_r, tr_g, tr_b));
    else
        SDL_SetColorKey(temp,
            (SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            0, 0, 0));
    image=SDL_DisplayFormat(temp);
    SDL_FreeSurface(temp);
    if(!image){
        fprintf(stderr,"Failed to convert image %s to native format\n", name);
        return NULL;
    }
    return image;
}

SDL_Surface* icon_duplicate(SDL_Surface* s, bool transparent, int tr_r, int tr_g, int tr_b)
{
    SDL_Surface* temp;
    SDL_Surface* ret;
    Sint32 x,y;
    if(!s)
        return 0;
    temp=SDL_CreateRGBSurface(
            s->flags,s->w,s->h,
            s->format->BitsPerPixel,
            s->format->Rmask,s->format->Gmask,
            s->format->Bmask,s->format->Amask);
    SDL_LockSurface(s);
    SDL_LockSurface(temp);
    for(y=0;y<s->h;y++)
        for(x=0;x<s->w;x++)
            putpixel(temp,x,y,getpixel(s,x,y));
    SDL_UnlockSurface(s);
    SDL_UnlockSurface(temp);
    if(transparent)
        SDL_SetColorKey(temp, 
            (SDL_SRCCOLORKEY|SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            tr_r, tr_g, tr_b));
    else
        SDL_SetColorKey(temp,
            (SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            0, 0, 0));
    ret=SDL_DisplayFormat(temp);
    SDL_FreeSurface(temp);
    return ret;
}

SDL_Surface* icon_half_assed_size(SDL_Surface* s, bool transparent, int tr_r, int tr_g, int tr_b)
{
    SDL_Surface* temp;
    SDL_Surface* ret;
    Sint32 x,y;
    Sint32 hw;
    Sint32 hh;
    if(!s)
        return 0;
    hw=s->w/2;
    hh=s->h/2;
    temp=SDL_CreateRGBSurface(
            s->flags,hw,hh,
            s->format->BitsPerPixel,
            s->format->Rmask,s->format->Gmask,
            s->format->Bmask,s->format->Amask);
    SDL_LockSurface(s);
    SDL_LockSurface(temp);
    for(y=0;y<hh;y++)
        for(x=0;x<hw;x++)
            putpixel(temp,x,y,getpixel(s,x*2,y*2));
    SDL_UnlockSurface(s);
    SDL_UnlockSurface(temp);
    if(transparent)
        SDL_SetColorKey(temp,
            (SDL_SRCCOLORKEY|SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            tr_r, tr_g, tr_b));
    else
        SDL_SetColorKey(temp,
            (SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            0, 0, 0));
    ret=SDL_DisplayFormat(temp);
    SDL_FreeSurface(temp);
    return ret;
}

/* private functions */

void generate_wall_edging(su_t wall)
{
    int n;
    int o;
    SDL_Surface *temp;
    if(!icons[ICON_WALL])
        return;
    for(n=ICON_EDGE_T;n<=ICON_EDGE_TBLR;n++){
        int w=n-ICON_EDGE_T;
        if(edged_walls[w]){
            SDL_FreeSurface(edged_walls[w]);
            edged_walls[w]=0;
        }
        temp=icon_duplicate(icons[ICON_WALL],FALSE,0,0,0);
        switch(n){
            case ICON_EDGE_T:       o=EDGE_T;   break;
            case ICON_EDGE_B:       o=EDGE_B;   break;
            case ICON_EDGE_L:       o=EDGE_L;   break;
            case ICON_EDGE_R:       o=EDGE_R;   break;
            case ICON_EDGE_TB:      o=EDGE_TB;  break;
            case ICON_EDGE_LR:      o=EDGE_LR;  break;
            case ICON_EDGE_TL:      o=EDGE_TL;  break;
            case ICON_EDGE_TR:      o=EDGE_TR;  break;
            case ICON_EDGE_BL:      o=EDGE_BL;  break;
            case ICON_EDGE_BR:      o=EDGE_BR;  break;
            case ICON_EDGE_TBL:     o=EDGE_TBL; break;
            case ICON_EDGE_TBR:     o=EDGE_TBR; break;
            case ICON_EDGE_TLR:     o=EDGE_TLR; break;
            case ICON_EDGE_BLR:     o=EDGE_BLR; break;
            default:                o=EDGE_TBLR;break;
        }
        if(o&EDGE_T)
            overlay_image(temp,wall_edges[wall][0],0,0);
        if(o&EDGE_B)
            overlay_image(temp,wall_edges[wall][1],0,0);
        if(o&EDGE_L)
            overlay_image(temp,wall_edges[wall][2],0,0);
        if(o&EDGE_R)
            overlay_image(temp,wall_edges[wall][3],0,0);
        SDL_SetColorKey(temp, 
            (SDL_SRCCOLORKEY|SDL_RLEACCEL),
            SDL_MapRGB(temp->format,
            0, 0, 0));
        edged_walls[n-ICON_EDGE_T]=SDL_DisplayFormat(temp);
        SDL_FreeSurface(temp);
    }
}
