/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _INPUT_H
#define _INPUT_H

#include <SDL.h>

#include "types.h"

/*
    only one keypress at any one time processed.
    we'll see...
*/

#define DEF_KEY_RATE_MS 50

enum INP_MVS
{
    INP_LEFT=0x01,
    INP_RIGHT=0x02,
    INP_UP=0x04,
    INP_DOWN=0x08,
    /* repeat? */
    INP_REP=0xff
};

struct xg_key
{
    SDLKey key;
    bool pressed;
};

struct xg_input
{
    struct xg_key** keys;
    int r_delay;
    int r_interval;
    int mouse_x;
    int mouse_y;
    bool mouse_b1;
    bool mouse_b2;
    bool quit;
    bool exit;
};

extern struct xg_input xginput;

struct xg_key** create_key_list_array(int count);
void destroy_key_list_array(struct xg_key** keylist);

void set_keys(struct xg_key** keys);

void key_repeat();
void key_repeat_on();
void key_repeat_off();

bool simple_poll_event();
void wait_till_pressed();
#endif
