/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MAPDISPLAY_H
#define MAPDISPLAY_H

#include "map.h"
#include "input.h"

enum MAP_KEYS
{
    MAP_KEY_UP,
    MAP_KEY_DOWN,
    MAP_KEY_LEFT,
    MAP_KEY_RIGHT,
    MAP_KEY_IN,
    MAP_KEY_OUT,
    MAP_KEY_HIDE,
    MAP_KEYS_XXX
};

enum MAP_ICONS
{
    MAP_FLOOR,
    MAP_WALL,
    MAP_MASK,
    MAP_EXIT,
    MAP_EXIT_OPEN,
    MAP_BLANK,
    MAP_SPACE,
    MAP_ICONS_XXX
};

extern struct xg_key** map_keys;

struct map_display_data
{
    struct xy center;   /* coordinates in map to use as center in display   */
    su_t zoom;          /* 8 = 8x8, 16 = 16x16, 32 = 32x32                  */

    su_t min_zoom;

    xy_t blk_count_x;   /* values dependant on zoom */
    xy_t blk_count_y;

    int map_tlx;
    int map_tly;
    int map_brx;
    int map_bry;
    SDL_Surface** zicons;
    SDL_Surface* icons32[MAP_ICONS_XXX];
    SDL_Surface* icons16[MAP_ICONS_XXX];
    SDL_Surface* icons8[MAP_ICONS_XXX];
};

extern struct map_display_data map_display;

bool map_display_create_keys();
void map_display_destroy_icons();
void map_display_destroy_keys();

void map_display_init();
void map_display_show();

#endif
