/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _MOVES_H
#define _MOVES_H

#include "movelist.h"
#include "player.h"


/* init_unsupported to be called after map loads, and before    *
 * player takes control. it checks the map for gravitating      *
 * objects which are not 'resting' against (ie are unsupported) *
 * anything. essentially this causes them to gravitate.         */
void init_unsupported();

/* determines if movement of object (not player) is possible */

ct_t move_object_init(struct xor_move* move);

/* move_gravity_process
    processes the movement of an object, how this object comes
    to be moving is decided by player_process_old_pos, and
    pushed_process_new_pos. the xor_move* xmv is the object
    (decided by the previous two functions) which is to move.
    this function checks if other objects need to move because
    this object is moving, and moves them also.
*/
void move_gravity_process();


/* move_unchain_blocked_bomb
    when a chain of objects has gravitated and the path blocked,
    look to see if there is a bomb in the chain. if so, remove
    it and let the remaining chain continue to be processed -
    returns TRUE if this is to happen
*/
struct xor_move* move_unchain_blocked_bomb(struct xmv_link* lnk);

void move_hard_push(struct xor_move* xmv);

su_t flip(su_t obj, su_t dir);

#endif
