/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _PLAY_XOR_H
#define _PLAY_XOR_H


#include "map.h"
#include "game_display.h"
#include "actions.h"
#include "player.h"
#include "input.h"

enum PLAY_KEYS
{
    PLAY_KEY_UP,
    PLAY_KEY_DOWN,
    PLAY_KEY_LEFT,
    PLAY_KEY_RIGHT,
    PLAY_KEY_SWAP,
    PLAY_KEY_MAP,
    PLAY_KEY_SCR_THRESH_1,
    PLAY_KEY_SCR_THRESH_2,
    PLAY_KEY_SCR_THRESH_3,
    PLAY_KEY_TOG_INDICATORS,
    #ifdef MAPDEVMODE
    PLAY_KEY_MAPDEV,
    #endif
    PLAY_KEYS_XXX
};

enum REPLAY_KEYS
{
    REPLAY_KEY_YES,
    REPLAY_KEY_NO,
    REPLAY_KEY_SAVE,
    REPLAY_KEY_CONTINUE,
    REPLAY_KEY_SPEED_1,
    REPLAY_KEY_SPEED_2,
    REPLAY_KEY_SPEED_3,
    REPLAY_KEY_SPEED_4,
    REPLAY_KEY_SPEED_5,
    REPLAY_KEY_SPEED_6,
    REPLAY_KEY_SPEED_7,
    REPLAY_KEY_SPEED_8,
    REPLAY_KEY_SPEED_9,
    REPLAY_KEYS_XXX
};

extern struct xg_key** play_keys;
extern struct xg_key** replay_keys;

struct xor_replay
{
    su_t    level;
    su_t*   moves;
}replay;

bool play_create_keys();
void play_destroy_keys();

bool    replay_xor(bool ask);
void    replay_save();
lvl_t   replay_load();

bool    play_xor(lvl_t level, bool from_start);

void dump_replay_data();
void dump_play_state(int mv, int state);

void inc_max_moves();

#endif

