/*
    XorGramana Copyright 2009 James W. Morris, james@jwm-art.net

    This file is part of XorGramana.

    XorGramana is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    XorGramana is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XorGramana.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "teleport.h"
#include "game_display.h"
#include "player.h"
#include "options.h"

#include <stdlib.h>

bool player_teleport(struct xor_move* pmv)
{
/*
    struct timespec rpause;
    struct timespec repause;
*/
    unsigned int flimit=SDL_GetTicks()+TICK_COUNT;
    su_t t;
    xy_t chkx[4]={1,0,-1,0};
    xy_t chky[4]={0,-1,0,1};
    su_t i;
    xy_t px;
    xy_t py;
    if((t=map_get_teleport(pmv->to_x,pmv->to_y)^1)>1)
        return FALSE;
    player_teleport_animate(pmv,TP_IN);
    map->data[pmv->from_y][pmv->from_x]=ICON_FLOOR;

    game_win_show(map->teleport[t].x,map->teleport[t].y);

    /* check teleport destination has not been blown up */
    if(map->data[map->teleport[t].y]
               [map->teleport[t].x]==ICON_TELEPORT)
    {
        /* check teleport exits are not blocked */
        for(i=0;i<4;i++){
            px=map->teleport[t].x+chkx[i];
            py=map->teleport[t].y+chky[i];
            if(map->data[py][px]==ICON_FLOOR){
                map->data[py][px]=pmv->from_obj;
                map->player[player.player].x=pmv->to_x=px;
                map->player[player.player].y=pmv->to_y=py;
                game_win_get_view_for(
                    map->teleport[t].x,
                    map->teleport[t].y,
                    &map->view[player.player].x,
                    &map->view[player.player].y);
                player_teleport_animate(pmv,TP_OUT);
                game_win_display();
                /*  flushinp(); */
                return TRUE;
            }
        }
    }
    /* sorry, we can't teleport you today due to snow on the road */
/*
    rpause.tv_sec=0;
    rpause.tv_nsec=750000000L;
    nanosleep(&rpause,&repause);
*/
    delay(flimit);
    flimit=SDL_GetTicks()+TICK_COUNT;
    pmv->to_x=pmv->from_x;
    pmv->to_y=pmv->from_y;
    game_win_display();
    player_teleport_animate(pmv,TP_OUT);
    map->data[pmv->from_y][pmv->from_x]=pmv->from_obj;
    /*  flushinp(); */
    return FALSE;
}

void player_teleport_animate(struct xor_move* pmv, enum TP_ANIM dir)
{
/*
    struct timespec rpause;
    struct timespec repause;
    xy_t x,y,stx,enx,xinc;
    struct xy* dmxy=0;
    struct xor_icon* icon=0;
    if(dir==TP_IN){
        if(!(dmxy=game_win_map_coord(pmv->from_x,pmv->from_y)))
            return; */ /* should be unlikely */ /*
        icon=&icons[pmv->from_obj];
        wattrset(game_win,COLOR_PAIR(ICON_FLOOR));
    }
    else{
        if(!(dmxy=game_win_map_coord(pmv->to_x,pmv->to_y)))
            return;*/ /* should be unlikely */ /*
        icon=&icons[pmv->from_obj];
        wattrset(game_win,COLOR_PAIR(pmv->from_obj));
    }
    rpause.tv_sec=0;
    if(player.replay)
        rpause.tv_nsec=options_replay_speed(options->replay_speed)/5;
    else
        rpause.tv_nsec=12500000L;
    for(y=dmxy->y;y<dmxy->y+ICON_H;y++){
        if(y&1){
            stx=dmxy->x+ICON_W-1;
            enx=dmxy->x-1;
            xinc=-1;
        }
        else{
            stx=dmxy->x;
            enx=dmxy->x+ICON_W;
            xinc=1;
        }
        for(x=stx;x!=enx;x+=xinc){
            mvwaddch(game_win,y,x,icon->chrs[y-dmxy->y][x-dmxy->x]);
            wrefresh(game_win);
            nanosleep(&rpause,&repause);
        }
    }
    free(dmxy);
    */
}
